{{- if .Values.statefulSet.enabled }}
apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: {{ .Release.Name }}
spec:
  selector:
    matchLabels:
      app: {{ .Release.Name }}
  serviceName: {{ .Release.Name }}
  replicas: {{ .Values.replicaCount }}
  template:
    metadata:
      labels:
        app: {{ .Release.Name }}
    spec:
      terminationGracePeriodSeconds: 10
{{- if .Values.nodeSelector.enabled }}
      nodeSelector:
        {{ .Values.nodeSelector.key }}: {{ .Values.nodeSelector.value }}
{{- end }}
      containers:
        - name: agent
          image: registry.gitlab.com/nevertheless.space/docker-registry/azuredevops-deploymentgroup:{{ $.Chart.AppVersion }}
          envFrom:
            - configMapRef:
                name: {{ .Release.Name }}
          env:
            - name: AZP_AGENT_NAME
              valueFrom:
                fieldRef:
                  fieldPath: metadata.name
          volumeMounts:
            - mountPath: /var/run/docker.sock
              name: docker-volume
            - name:  data
              mountPath: {{ .Values.workingDir }}
{{- if .Values.limits.enabled }}
          resources:
            requests:
              memory: '{{ .Values.limits.requestedMemory }}'
              cpu: '{{ .Values.limits.requestedCPU }}'
            limits:
              memory: '{{ .Values.limits.memoryLimit }}'
              cpu: '{{ .Values.limits.CPULimit }}'
{{- end }}
      volumes:
        - name: docker-volume
          hostPath:
            path: /var/run/docker.sock
  volumeClaimTemplates:
  - metadata:
      name:  data
    spec:
      accessModes: [ "ReadWriteOnce" ]
      storageClassName: '{{ .Values.statefulSet.storageClassName }}'
      resources:
        requests:
          storage: {{ .Values.statefulSet.storageSize }}
{{- end }}